// BufferOptionsDialog.cpp : implementation file
//
#include "stdafx.h"
#include "resource.h"
#include "BufferOptionsDialog.h"

#include "globals.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBufferOptionsDialog dialog


CBufferOptionsDialog::CBufferOptionsDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CBufferOptionsDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBufferOptionsDialog)
	m_BufferEdit = _T("");
	m_TimerEdit = _T("");
	//}}AFX_DATA_INIT
}


void CBufferOptionsDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBufferOptionsDialog)
	DDX_Control(pDX, IDC_TIMER_SLIDER, m_TimerSlider);
	DDX_Control(pDX, IDC_BUFFER_SLIDER, m_BufferSlider);
	DDX_Text(pDX, IDC_BUFFER_EDIT, m_BufferEdit);
	DDX_Text(pDX, IDC_TIMER_EDIT, m_TimerEdit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBufferOptionsDialog, CDialog)
	//{{AFX_MSG_MAP(CBufferOptionsDialog)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBufferOptionsDialog message handlers

BOOL CBufferOptionsDialog::OnInitDialog() 
{
	CString strBufferText, strTimerText;
	CString strBufferValue, strTimerValue;

	CDialog::OnInitDialog();
	
	if (nOptionsMode == OPTIONS_MODE_KEYBOARD){
		this->SetWindowText(_T("Keyboard Options"));
		strBufferText.Format( 
			_T("Lower values increase the keyboard's responsiveness, but may cause the sound to break up.  Default is %d milliseconds."),
			DEFAULT_KEYBOARD_BUFFERSIZE);
		strTimerText.Format( 
			_T("Determines how much of the buffer gets played before it's refilled.  Default is %d%%."),
			DEFAULT_KEYBOARD_TIMERFREQUENCY);
		m_BufferSlider.SetRange(KEYBOARD_BUFFER_MIN, KEYBOARD_BUFFER_MAX);
		m_BufferSlider.SetPos(nKeyboardBufferSize);
		m_TimerSlider.SetRange(KEYBOARD_TIMERFREQUENCY_MIN, KEYBOARD_TIMERFREQUENCY_MAX);
		m_TimerSlider.SetPos(nKeyboardTimerFrequency);
		strBufferValue.Format(_T("%dms"), nKeyboardBufferSize);
		strTimerValue.Format(_T("%d%%"), nKeyboardTimerFrequency);
	}
	if (nOptionsMode == OPTIONS_MODE_SONG){
		this->SetWindowText(_T("Song Options"));
		strBufferText.Format( 
			_T("Higher values may make the player more reliable, but increase the delay.  Default is %.1f seconds."),
			(float)DEFAULT_SONG_BUFFERSIZE / (float)1000);
		strTimerText.Format( 
 			_T("Determines how much of the buffer gets played before it's refilled.  Lower values may may make the player more reliable.  Default is %d%%."),
			DEFAULT_SONG_TIMERFREQUENCY);
		m_BufferSlider.SetRange(SONG_BUFFER_MIN, SONG_BUFFER_MAX);
		m_BufferSlider.SetPos(nSongBufferSize);
		m_TimerSlider.SetRange(SONG_TIMERFREQUENCY_MIN, SONG_TIMERFREQUENCY_MAX);
		m_TimerSlider.SetPos(nSongTimerFrequency);
		strBufferValue.Format(_T("%.1fs"), (float)nSongBufferSize/(float)1000);
		strTimerValue.Format(_T("%d%%"), nSongTimerFrequency);
	}
	this->SetDlgItemText(IDC_BUFFER_STATIC, strBufferText);
	this->SetDlgItemText(IDC_TIMER_STATIC, strTimerText);
	this->GetDlgItem(IDC_BUFFER_EDIT)->SetWindowText(strBufferValue);
	this->GetDlgItem(IDC_TIMER_EDIT)->SetWindowText(strTimerValue);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CBufferOptionsDialog::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CString strBufferValue, strTimerValue;

	if ((CSliderCtrl *)pScrollBar == &m_BufferSlider) {
		if (nOptionsMode == OPTIONS_MODE_KEYBOARD) {
			nKeyboardBufferSize = m_BufferSlider.GetPos();
			strBufferValue.Format(_T("%dms"), nKeyboardBufferSize);
		}
		else {
			nSongBufferSize = m_BufferSlider.GetPos();
			strBufferValue.Format(_T("%.1fs"), (float)nSongBufferSize/(float)1000);
		}
		this->GetDlgItem(IDC_BUFFER_EDIT)->SetWindowText(strBufferValue);
	}
	else if ((CSliderCtrl *)pScrollBar == &m_TimerSlider) {
		if (nOptionsMode == OPTIONS_MODE_KEYBOARD) {
			nKeyboardTimerFrequency = m_TimerSlider.GetPos();
			strTimerValue.Format(_T("%d%%"), nKeyboardTimerFrequency);
		}
		else {
			nSongTimerFrequency = m_TimerSlider.GetPos();
			strTimerValue.Format(_T("%d%%"), nSongTimerFrequency);
		}
		this->GetDlgItem(IDC_TIMER_EDIT)->SetWindowText(strTimerValue);
	}

	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
