// MODPlayCEDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MODPlayCE.h"
#include "MODPlayCEDlg.h"
#include "KeyboardDialog.h"
#include "BufferOptionsDialog.h"

#include "MikMod.h"
#include "globals.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//globals

int nSongTimerFrequency;
int nKeyboardTimerFrequency;
int nSongBufferSize;
int nKeyboardBufferSize;

char szModuleName[MAX_PATH];
MODULE *m_module;
CSliderCtrl *pSlider;
CMODPlayCEDlg *pDlg;

void SimpleCheatConversionUnicodeToANSI(char * pUnicodeString, char * pANSIString, long length)
//FIXME -- this conversion should not be necessary if we fix
//LibMikModWinCE to _wfopen instead of fopen
{
	long i;
	
	for (i = 0; i < length; i++) {
		pANSIString[i] = pUnicodeString[i*2];
	}
}

void CALLBACK EXPORT SongTimerProc(
   HWND hWnd,      // handle of CWnd that called SetTimer
   UINT nMsg,      // WM_TIMER
   UINT nIDEvent,   // timer identification
   DWORD dwTime    // system time
)
{
	static int LastSliderPos;
	CString cstrInfo;

	if (Player_Active()) {
		//if slider was moved by user
		if (pSlider->GetPos() != LastSliderPos)
			Player_SetPosition(pSlider->GetPos());
		MikMod_Update();
		//update slider
		pSlider->SetPos(m_module->sngpos);
		LastSliderPos = m_module->sngpos;
		//update info
		cstrInfo.Format(_T("Position: %d of %d total positions\nRow in pattern: %d"),
			m_module->sngpos, m_module->numpos, m_module->patpos);
		pDlg->SetDlgItemText(IDC_STATIC_PROGRESS_TEXT, cstrInfo);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CMODPlayCEDlg dialog

CMODPlayCEDlg::CMODPlayCEDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMODPlayCEDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMODPlayCEDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMODPlayCEDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMODPlayCEDlg)
	DDX_Control(pDX, IDC_BTNOPEN, m_BtnOpen);
	DDX_Control(pDX, IDC_BTNTEST, m_BtnTest);
	DDX_Control(pDX, IDC_BTNPLAYPAUSE, m_BtnPlayPause);
	DDX_Control(pDX, IDC_SLIDER, m_Slider);
	DDX_Control(pDX, IDC_BTNSTOP, m_BtnStop);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMODPlayCEDlg, CDialog)
	//{{AFX_MSG_MAP(CMODPlayCEDlg)
	ON_BN_CLICKED(IDC_BTNOPEN, OnBtnOpen)
	ON_BN_CLICKED(IDC_BTNSTOP, OnBtnStop)
	ON_BN_CLICKED(IDC_BTNPLAYPAUSE, OnBtnPlayPause)
	ON_BN_CLICKED(IDC_BTNTEST, OnBtnTest)
	ON_BN_CLICKED(IDC_SONG_OPTIONS_BUTTON, OnSongOptionsButton)
	ON_BN_CLICKED(IDC_KEYBOARD_OPTIONS_BUTTON, OnKeyboardOptionsButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMODPlayCEDlg message handlers

BOOL CMODPlayCEDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here

	//set buffer and timer values
	nSongBufferSize = DEFAULT_SONG_BUFFERSIZE;
	nSongTimerFrequency = DEFAULT_SONG_TIMERFREQUENCY;
	nKeyboardBufferSize = DEFAULT_KEYBOARD_BUFFERSIZE;
	nKeyboardTimerFrequency = DEFAULT_KEYBOARD_TIMERFREQUENCY;

	//disable play and stop buttons
	m_BtnPlayPause.EnableWindow(FALSE);
	m_BtnStop.EnableWindow(FALSE);
	m_BtnTest.EnableWindow(FALSE);
	
	pSlider = &m_Slider;
	pDlg = this;

	//setup mikmod
	/* register all the drivers */
	MikMod_RegisterAllDrivers();
	/* register all the module loaders */
	MikMod_RegisterAllLoaders();
	/* initialize the library */
	md_mode |= DMODE_SOFT_MUSIC;
	MikMod_Init("");

	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CMODPlayCEDlg::OnBtnOpen() 
{
	OPENFILENAME ofn;
	TCHAR   szFile[MAX_PATH] = TEXT("\0");
	CString cstrName;

	memset( &(ofn), 0, sizeof(ofn));
	ofn.lStructSize   = sizeof(ofn);
	ofn.hwndOwner = m_hWnd;
	ofn.lpstrFile = szFile;
	ofn.nMaxFile = MAX_PATH;   

	ofn.lpstrFilter = TEXT("MOD-type files\0*.mod;*.med;*.s3m;*.stm;*.xm\0");   
	ofn.lpstrTitle = TEXT("Open MOD or similar file");
	ofn.Flags = OFN_EXPLORER;
	//get a file to open, if any
	if (GetOpenFileName(&ofn)) {

		//reset mikmod in case we're playing
		MikMod_DisableOutput();
		MikMod_Exit();
		MikMod_SetWinCEBufferSize(nSongBufferSize / 4);
		MikMod_Init("");

		//cheat to load file (FIXME (in libmikmod))
		SimpleCheatConversionUnicodeToANSI((char*)szFile, szModuleName, MAX_PATH);
		m_module = Player_Load(szModuleName, 64, 0);
		// enable Play button
		m_BtnPlayPause.EnableWindow(TRUE);
		m_BtnTest.EnableWindow(TRUE);
		//change caption
		this->SetDlgItemText(IDC_BTNPLAYPAUSE, _T("&Play"));
		// set up slider
		m_Slider.SetRange(0, m_module->numpos);
		m_Slider.SetPageSize(10);
		// set up songname and info
		cstrName.Format(_T("Module name: %S\nNumber of samples: %d"),
			m_module->songname, m_module->numsmp);
		SetDlgItemText(IDC_STATIC_FILENAME, cstrName);
		SetDlgItemText(IDC_STATIC_PROGRESS_TEXT, _T(""));
		//set slider (back) to zero
		pSlider->SetPos(m_module->sngpos);
	}
}


void CMODPlayCEDlg::OnBtnStop() 
{
	CString cstrButtonCaption;
    
	//disable Stop button
	m_BtnStop.EnableWindow(FALSE);

	//set Play button caption (back) to Play
	cstrButtonCaption = _T("&Play");
	this->SetDlgItemText(IDC_BTNPLAYPAUSE, cstrButtonCaption);

	//change caption
	this->SetDlgItemText(IDC_BTNPLAYPAUSE, _T("&Play"));
	this->SetDlgItemText(IDC_STATIC_PROGRESS_TEXT, _T(""));

	//kill timer
	KillTimer(ID_SONG_TIMER);

	//FIXME: kludged cause it dies if I just do a Player_Stop. Why?
	//reset mikmod and reload file
	MikMod_DisableOutput();
	Player_Free(m_module);
	MikMod_Exit();
	MikMod_SetWinCEBufferSize(nSongBufferSize / 4);
	MikMod_Init("");
	m_module = Player_Load(szModuleName, 64, 0);

	//stop playing
	Player_Stop();

	//set slider and song back to zero
	pSlider->SetPos(0);
	Player_SetPosition(0);
}


void CMODPlayCEDlg::OnBtnPlayPause() 
{
	CString cstrButtonCaption;
    
	this->GetDlgItemText(IDC_BTNPLAYPAUSE, cstrButtonCaption);

	//if we're not playing, start playing and change button caption to Pause
	if (cstrButtonCaption == _T("&Play")) {
		//start playing
		Player_Start(m_module);
		//setup timer for callback every (nSongTimerFrequency * nSongBufferSize)/100 milliseconds
		SetTimer(ID_SONG_TIMER, (nSongTimerFrequency * nSongBufferSize)/100, &SongTimerProc);
		//change caption
		cstrButtonCaption = _T("&Pause");
		this->SetDlgItemText(IDC_BTNPLAYPAUSE, cstrButtonCaption);
		//enable Stop button
		m_BtnStop.EnableWindow(TRUE);
	}
	//else, pause playing and change button caption to Play
	else {
		//stop playing
	    Player_Stop();
		//change caption
		cstrButtonCaption = _T("&Play");
		this->SetDlgItemText(IDC_BTNPLAYPAUSE, cstrButtonCaption);
		//kill timer
		KillTimer(ID_SONG_TIMER);
		//disable Stop button
		m_BtnStop.EnableWindow(FALSE);
	}
}

void CMODPlayCEDlg::OnBtnTest() 
{
	CKeyboardDialog dlg;

	//set output to small buffer size
	SetMikModBufferSize(nKeyboardBufferSize);

	dlg.DoModal();
	//set output back to bigger buffer size
	SetMikModBufferSize(nSongBufferSize);
}

void CMODPlayCEDlg::SetMikModBufferSize(int nNewBufferSize)
{
	//FIXME: this should work with just a MikMod_Reset() but doesn't;
	//so we exit, set buffer size, restart, and reload the module
	MikMod_DisableOutput();
	MikMod_Exit();
	MikMod_SetWinCEBufferSize(nNewBufferSize / NUM_BUFFERS);
	MikMod_Init("");
	m_module = Player_Load(szModuleName, 64, 0);
	MikMod_EnableOutput();
}

void CMODPlayCEDlg::OnSongOptionsButton() 
{
	CBufferOptionsDialog dlg;

	dlg.nOptionsMode = OPTIONS_MODE_SONG;

	//stop everything
	OnBtnStop();

	dlg.DoModal(); // there *is* no cancel...MUHAHAHAHAH
}

void CMODPlayCEDlg::OnKeyboardOptionsButton() 
{
	CBufferOptionsDialog dlg;

	dlg.nOptionsMode = OPTIONS_MODE_KEYBOARD;

	//stop everything
	OnBtnStop();

	dlg.DoModal(); // there *is* no cancel...MUHAHAHAHAH
}
